library basic_class;

import 'dart:async';
import 'dart:io';
import 'package:ebisu/ebisu_utils.dart' as ebisu_utils;
import 'package:path/path.dart';
// custom <additional imports>
// end <additional imports>


class ClassNoInit {
  String mString;
  int mInt;
  double mDouble;
  bool mBool;
  List<int> mListInt;
  Map<String,String> mStringString;

  // custom <class ClassNoInit>
  // end <class ClassNoInit>
}

class ClassWithInit {
  String mString = 'foo';
  int mInt = 0;
  double mDouble = 0.0;
  num mNum = 3.14;
  bool mBool = false;
  List<int> mListInt = [];
  Map<String,String> mStringString = {};

  // custom <class ClassWithInit>
  // end <class ClassWithInit>
}

class ClassWithInferredType {
  String mString = 'foo';
  int mInt = 0;
  double mDouble = 1.0;
  bool mBool = false;
  List mList = [];
  Map mMap = {};

  // custom <class ClassWithInferredType>
  // end <class ClassWithInferredType>
}

class ClassReadOnly {
  String get mString => _mString;
  int get mInt => _mInt;
  double get mDouble => _mDouble;
  bool get mBool => _mBool;
  List get mList => _mList;
  Map get mMap => _mMap;

  // custom <class ClassReadOnly>
  // end <class ClassReadOnly>
  String _mString = 'foo';
  int _mInt = 3;
  double _mDouble = 3.14;
  bool _mBool = false;
  List _mList = [1, 2, 3];
  Map _mMap = {1: 2};
}

class ClassInaccessible {

  // custom <class ClassInaccessible>
  // end <class ClassInaccessible>
  String _mString = 'foo';
  int _mInt = 3;
  double _mDouble = 3.14;
  bool _mBool = false;
  List _mList = [1, 2, 3];
  Map _mMap = {1: 2};
}

class ClassJson {
  String get mString => _mString;
  int get mInt => _mInt;
  double get mDouble => _mDouble;
  bool get mBool => _mBool;
  List get mList => _mList;
  Map get mMap => _mMap;

  // custom <class ClassJson>
  // end <class ClassJson>

  Map toJson() {
    return {
    "mString": ebisu_utils.toJson(mString),
    "mInt": ebisu_utils.toJson(mInt),
    "mDouble": ebisu_utils.toJson(mDouble),
    "mBool": ebisu_utils.toJson(mBool),
    "mList": ebisu_utils.toJson(mList),
    "mMap": ebisu_utils.toJson(mMap),
    };
  }

  static ClassJson fromJson(String json) {
    Map jsonMap = convert.JSON.decode(json);
    ClassJson result = new ClassJson();
    result._fromJsonMapImpl(jsonMap);
    return result;
  }

  static ClassJson fromJsonMap(Map jsonMap) {
    ClassJson result = new ClassJson();
    result._fromJsonMapImpl(jsonMap);
    return result;
  }

  void _fromJsonMapImpl(Map jsonMap) {
    _mString = jsonMap["mString"];
    _mInt = jsonMap["mInt"];
    _mDouble = jsonMap["mDouble"];
    _mBool = jsonMap["mBool"];
    _mList = jsonMap["mList"];
    _mMap = jsonMap["mMap"];
  }
  String _mString = 'foo';
  int _mInt = 3;
  double _mDouble = 3.14;
  bool _mBool = false;
  List _mList = [1, 2, 3];
  Map _mMap = {1: 2};
}

class ClassJsonOuter {
  ClassJson get mNested => _mNested;

  // custom <class ClassJsonOuter>
  // end <class ClassJsonOuter>

  Map toJson() {
    return {
    "mNested": ebisu_utils.toJson(mNested),
    };
  }

  static ClassJsonOuter fromJson(String json) {
    Map jsonMap = convert.JSON.decode(json);
    ClassJsonOuter result = new ClassJsonOuter();
    result._fromJsonMapImpl(jsonMap);
    return result;
  }

  static ClassJsonOuter fromJsonMap(Map jsonMap) {
    ClassJsonOuter result = new ClassJsonOuter();
    result._fromJsonMapImpl(jsonMap);
    return result;
  }

  void _fromJsonMapImpl(Map jsonMap) {
    _mNested = (jsonMap["mNested"] is Map)?
      ClassJson.fromJsonMap(jsonMap["mNested"]) :
      ClassJson.fromJson(jsonMap["mNested"]);
  }
  ClassJson _mNested = new ClassJson();
}

// custom <library basic_class>
// end <library basic_class>

